#!/usr/bin/python3
import sys

def check(what, message):
    if not what:
        print(message)
        quit(1)

if len(sys.argv) != 3:
    sys.stderr.write('Internal error: Bad number of arguments.\n') 
    quit(1)

fin = open(sys.argv[1], 'r');
fout = open(sys.argv[2], 'r');

def wread():
    result = {}
    n = int(fin.readline())
    for i in range(n):
        word, value = fin.readline().split()
        result[word] = int(value)
    return result

A,B,C = wread(), wread(), wread()

n = int(fin.readline())
try:
    ans = fout.readlines()
except UnicodeDecodeError: check(False, 'Unicode error.')
check(len(ans) == n, 'Wrong number of lines.')
used = set()

for i in range(n):
    a,b,c = fin.readline().split()
    value = A[a] + B[b] + C[c] + 1

    their = ans[i].split()
    check(len(their) == 3, 'Line %d does not have three words.' % (i+1))
    a,b,c = their
    check(A.get(a,False) and B.get(b,False) and C.get(c,False), 
          'Line %d is not a valid insult.' % (i+1))
    
    check(not (a,b,c) in used, 'You have already used the insult on line %d.' % (i+1))
    used.add((a,b,c))
    check(A[a] + B[b] + C[c] == value, 'Insult on line %d does not have the right strength.' % (i+1))
    
fin.close()
fout.close()
print('OK')
